/*
* DSD Converter plugin
* Copyright (c) 2016 Maxim V.Anisiutkin <maxim.anisiutkin@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with FFmpeg; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#ifndef _DSD_PROCESSOR_SERVICE_H_INCLUDED
#define _DSD_PROCESSOR_SERVICE_H_INCLUDED

#include <foobar2000.h>

class dsd_processor_service : public service_base {
public:
	virtual GUID get_guid() = 0;
	virtual const char* get_name() = 0;
	virtual bool is_active() = 0;
	virtual bool is_changed() = 0;
	virtual void set_volume(double p_volume_dB) = 0;
	virtual bool start(t_size p_inp_channels, unsigned p_inp_samplerate, unsigned p_inp_channel_config, t_size& p_out_channels, unsigned& p_out_samplerate, unsigned& p_out_channel_config) = 0;
	virtual void stop() = 0;
	virtual void run(const void* p_inp_pcmdsd, t_size p_inp_samples, pfc::array_t<t_uint8>& p_out_dsd) = 0;
	FB2K_MAKE_SERVICE_INTERFACE_ENTRYPOINT(dsd_processor_service);
};

#endif
